package com.hfkj.dao;

import com.hfkj.entity.BsDiscountPk;
import com.hfkj.entity.BsDiscountPkExample.Criteria;
import com.hfkj.entity.BsDiscountPkExample.Criterion;
import com.hfkj.entity.BsDiscountPkExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsDiscountPkSqlProvider {

    public String countByExample(BsDiscountPkExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_discount_pk");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsDiscountPkExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_discount_pk");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsDiscountPk record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_discount_pk");
        
        if (record.getDiscountPkNo() != null) {
            sql.VALUES("discount_pk_no", "#{discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.VALUES("discount_pk_name", "#{discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getDescribe() != null) {
            sql.VALUES("`describe`", "#{describe,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.VALUES("list_img", "#{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.VALUES("content", "#{content,jdbcType=VARCHAR}");
        }
        
        if (record.getSalePrice() != null) {
            sql.VALUES("sale_price", "#{salePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleNum() != null) {
            sql.VALUES("sale_num", "#{saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.VALUES("start_time", "#{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.VALUES("end_time", "#{endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateUserType() != null) {
            sql.VALUES("create_user_type", "#{createUserType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateUserId() != null) {
            sql.VALUES("create_user_id", "#{createUserId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateUserName() != null) {
            sql.VALUES("create_user_name", "#{createUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsDiscountPkExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("discount_pk_no");
        sql.SELECT("discount_pk_name");
        sql.SELECT("`describe`");
        sql.SELECT("list_img");
        sql.SELECT("content");
        sql.SELECT("sale_price");
        sql.SELECT("sale_num");
        sql.SELECT("start_time");
        sql.SELECT("end_time");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("create_user_type");
        sql.SELECT("create_user_id");
        sql.SELECT("create_user_name");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_discount_pk");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsDiscountPk record = (BsDiscountPk) parameter.get("record");
        BsDiscountPkExample example = (BsDiscountPkExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_pk");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getDiscountPkNo() != null) {
            sql.SET("discount_pk_no = #{record.discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.SET("discount_pk_name = #{record.discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getDescribe() != null) {
            sql.SET("`describe` = #{record.describe,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        }
        
        if (record.getSalePrice() != null) {
            sql.SET("sale_price = #{record.salePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleNum() != null) {
            sql.SET("sale_num = #{record.saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{record.endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateUserType() != null) {
            sql.SET("create_user_type = #{record.createUserType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateUserId() != null) {
            sql.SET("create_user_id = #{record.createUserId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateUserName() != null) {
            sql.SET("create_user_name = #{record.createUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_pk");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("discount_pk_no = #{record.discountPkNo,jdbcType=VARCHAR}");
        sql.SET("discount_pk_name = #{record.discountPkName,jdbcType=VARCHAR}");
        sql.SET("`describe` = #{record.describe,jdbcType=VARCHAR}");
        sql.SET("list_img = #{record.listImg,jdbcType=VARCHAR}");
        sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        sql.SET("sale_price = #{record.salePrice,jdbcType=DECIMAL}");
        sql.SET("sale_num = #{record.saleNum,jdbcType=INTEGER}");
        sql.SET("start_time = #{record.startTime,jdbcType=TIMESTAMP}");
        sql.SET("end_time = #{record.endTime,jdbcType=TIMESTAMP}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("create_user_type = #{record.createUserType,jdbcType=INTEGER}");
        sql.SET("create_user_id = #{record.createUserId,jdbcType=BIGINT}");
        sql.SET("create_user_name = #{record.createUserName,jdbcType=VARCHAR}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsDiscountPkExample example = (BsDiscountPkExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsDiscountPk record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_discount_pk");
        
        if (record.getDiscountPkNo() != null) {
            sql.SET("discount_pk_no = #{discountPkNo,jdbcType=VARCHAR}");
        }
        
        if (record.getDiscountPkName() != null) {
            sql.SET("discount_pk_name = #{discountPkName,jdbcType=VARCHAR}");
        }
        
        if (record.getDescribe() != null) {
            sql.SET("`describe` = #{describe,jdbcType=VARCHAR}");
        }
        
        if (record.getListImg() != null) {
            sql.SET("list_img = #{listImg,jdbcType=VARCHAR}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{content,jdbcType=VARCHAR}");
        }
        
        if (record.getSalePrice() != null) {
            sql.SET("sale_price = #{salePrice,jdbcType=DECIMAL}");
        }
        
        if (record.getSaleNum() != null) {
            sql.SET("sale_num = #{saleNum,jdbcType=INTEGER}");
        }
        
        if (record.getStartTime() != null) {
            sql.SET("start_time = #{startTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getEndTime() != null) {
            sql.SET("end_time = #{endTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateUserType() != null) {
            sql.SET("create_user_type = #{createUserType,jdbcType=INTEGER}");
        }
        
        if (record.getCreateUserId() != null) {
            sql.SET("create_user_id = #{createUserId,jdbcType=BIGINT}");
        }
        
        if (record.getCreateUserName() != null) {
            sql.SET("create_user_name = #{createUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsDiscountPkExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}